/*  _ __   __ _ ___ __  __
** | '_ \ / _` |_ _|  \/  | naim
** | | | | (_| || || |\/| | Copyright 1998, 1999 Daniel Reed <n@ml.org>
** |_| |_|\__,_|___|_|  |_| ncurses-based, FAIM-based AIM client
** 
** FAIM Copyright 1998 Adam Fritzler <afritz@iname.com>
** FAIM uses code Copyright 1998 Brock Wilcox <awwaiid@iname.com>
*/
#include <naim.h>

extern WINDOW	*win_status;
extern int	iamaway;
extern naimses_t	naimses;
extern faimconf_t	faimconf;
extern void	*nfire_c;
extern time_t	now;

time_t	idletime = 0;
int	sentidle = 0;

void	updateidletime(void) {
//	if (sentidle == 1)
//		aim_bos_setidle(nfaim_sess, nfaim_conn, 0);
	sentidle = 0;
	idletime = now;
	bupdate();
}

void	event_handle(time_t now) {
	static int	tprint, autoaway;
	char    pingbuf[100];

	debug_printf("event_handle(%lu)\n", now);

	if ((naimses.connected) && (faimconf.nolagcheck == 0)) {
		snprintf(pingbuf, 100, "<!--PING:%lu:-->", now);
		// now rounded to the nearest minute
		firetalk_im_send_message(nfire_c, naimses.sn, pingbuf, 1);
	}

	tprint = secs_getvar_int("tprint");
	if (iamaway == 0)
		autoaway = secs_getvar_int("autoaway");
	else
		autoaway = 0;
	if (naimses.connected && !sentidle && ((now - idletime) > 300)) {
		sentidle = 1;
//		aim_bos_setidle(nfaim_sess, nfaim_conn, now - idletime);
	}
	if ((autoaway > 0) && ((now - idletime) >= 60*autoaway)) {
		cechof("You have been idle for more than %i minutes.\n",
			autoaway);
		setaway();
	}
	if (tprint != 0) {
		struct tm	*tmptr;

		tmptr = localtime(&now);
		assert(tmptr != NULL);
		if ((tmptr->tm_min)%tprint == 0) {
			hwprintf(win_status, IMWIN_TEXT_U,
				"<I>-----</I> [<B>%02i</B>:<B>%02i</B>] "
				"<I>-----</I><br>", tmptr->tm_hour,
				tmptr->tm_min);
		}
	}
	bupdate();
}
